package com.zm.order.tool.server.engine;

import com.alibaba.fastjson.JSON;
import com.zm.order.tool.server.constants.ImageEnum;
import org.springframework.util.CollectionUtils;

import java.util.*;

/**
 * 图片导航
 *
 * @author nianchang
 * @ClassName ParseEngine3
 * @date 2021/06/17 10:58 上午
 */
@SuppressWarnings("all")
public class ParseEngine3 {

    public static Map<String, Object> parse(Map<String, Object> BaseMap, Map<String, Object> dataMap, String elName) {
        String id = BaseMap.get("id") != null ? BaseMap.get("id").toString() : "";
        Integer marginTop = BaseMap.get("marginTop") != null ? Integer.valueOf(BaseMap.get("marginTop").toString()) : 0;
        Integer marginBottom = BaseMap.get("marginBottom") != null ? Integer.valueOf(BaseMap.get("marginBottom").toString()) : 0;
        String backgroundColor = BaseMap.get("backgroundColor") != null ? BaseMap.get("backgroundColor").toString() : "";
        Integer marginLeft = BaseMap.get("marginLelftRight") != null ? Integer.valueOf(BaseMap.get("marginLelftRight").toString()) : 0;
        Integer marginRight = BaseMap.get("marginLelftRight") != null ? Integer.valueOf(BaseMap.get("marginLelftRight").toString()) : 0;

        Integer borderRadius = dataMap.get("borderRadius") != null ? Integer.valueOf(dataMap.get("borderRadius").toString()) : 0;
        boolean isShowTitle = dataMap.get("titleVisible") != null ? Boolean.valueOf(dataMap.get("titleVisible").toString()) : false;

        List<Map> imgsList = new ArrayList<>();
        if (Objects.nonNull(dataMap.get("imgs"))) {
            List<Map> imgsList1 = JSON.parseArray(dataMap.get("imgs").toString(), Map.class);
            imgsList.addAll(imgsList1);
        }

        Map<String, Object> source = buildDataSource(elName, marginTop, marginBottom, imgsList, borderRadius,
                backgroundColor, isShowTitle, marginLeft, marginRight, id);
        return source;
    }

    private static Map<String, Object> buildDataSource(String elName, Integer marginTop, Integer marginBottom,
                                                       List<Map> imgsList, Integer borderRadius, String backgroundColor,
                                                       boolean isShowTitle, Integer marginLeft,
                                                       Integer marginRight, String id) {
        Map<String, Object> data = new HashMap<>();
        data.put("elName", elName);
        data.put("title", "图片导航");
        Map<String, Object> map = buildCommonStyleMap(marginTop, marginBottom, backgroundColor, borderRadius, marginLeft, marginRight);
        data.put("commonStyle", map);
        data.put("isFixed", false);
        data.put("propsValue", buildPropsValue(imgsList, isShowTitle));
        data.put("events", buildEvents());
        data.put("icon", "qimai-tupian");
        data.put("id", id);
        String miniStyle = BuildStyle.build(map, elName);
        data.put("miniStyle", miniStyle);
        return data;
    }

    private static Map<String, Object> buildEvents() {
        Map<String, Object> eventsMap = new HashMap<>();
        eventsMap.put("type", "");
        eventsMap.put("page", buildPage());
        eventsMap.put("phone", "");
        eventsMap.put("audioUrl", "");
        eventsMap.put("alipay", buildAliPay());
        eventsMap.put("map", buildMap());
        return eventsMap;
    }

    private static Map<String, Object> buildMap() {
        Map<String, Object> map = new HashMap<>();
        map.put("lng", "");
        map.put("lat", "");
        map.put("name", "");
        map.put("address", "");
        return map;
    }

    private static Map<String, Object> buildAliPay() {
        Map<String, Object> alipay = new HashMap<>();
        alipay.put("tntInstId", "");
        alipay.put("scene", "");
        return alipay;
    }

    private static Map<String, Object> buildPage() {
        Map<String, Object> page = new HashMap<>();
        page.put("link", "");
        page.put("linkType", "");
        page.put("linkText", "");
        page.put("extraData", new HashMap<>());
        return page;
    }

    private static Map<String, Object> buildPropsValue(List<Map> imgsList, boolean isShowTitle) {
        Map<String, Object> propsValue = new HashMap<>();
        propsValue.put("isShowTitle", isShowTitle);
        propsValue.put("imgs", buildImgs(imgsList));
        return propsValue;
    }

    private static List<Map<String, Object>> buildImgs(List<Map> imgsList) {
        List<Map<String, Object>> imgs = new ArrayList<>();
        if (!CollectionUtils.isEmpty(imgsList)) {
            for (Map<String, Object> map : imgsList) {
                Map<String, Object> imgsMap = new HashMap<>();
                String link = Objects.nonNull(map.get("link")) ? map.get("link").toString() : "";
                String linkText = Objects.nonNull(map.get("link_text")) ? map.get("link_text").toString() : "";
                ImageEnum imageEnum = ImageEnum.getValue(link);
                if (imageEnum != null) {
                    link = imageEnum.getNewValue();
                    linkText = imageEnum.getDesc();
                }
                imgsMap.put("title", Objects.nonNull(map.get("title")) ? map.get("title") : "");
                imgsMap.put("link", link);
                imgsMap.put("linkType", Objects.nonNull(map.get("link_ty")) ? map.get("link_ty") : "");
                imgsMap.put("linkText", linkText);
                imgsMap.put("img", Objects.nonNull(map.get("img")) ? map.get("img") : "");
                imgs.add(imgsMap);
            }
        }
        return imgs;
    }

    private static Map<String, Object> buildPoints(String activeColor, Double inactiveOpacity, Integer bottomDistance) {
        Map<String, Object> points = new HashMap<>();
        points.put("bottomDistance", bottomDistance);
        points.put("inactiveOpacity", inactiveOpacity);
        points.put("activeColor", activeColor);
        return points;
    }

    private static Map<String, Object> buildCommonStyleMap(Integer marginTop, Integer marginBottom,
                                                           String backgroundColor, Integer borderRadius, Integer marginLeft,
                                                           Integer marginRight) {
        Map<String, Object> commonStyle = new HashMap<>();
        commonStyle.put("position", "relative");
        commonStyle.put("height", 90);
        commonStyle.put("top", 0);
        commonStyle.put("left", 0);
        commonStyle.put("paddingTop", 0);
        commonStyle.put("paddingLeft", 0);
        commonStyle.put("paddingRight", 0);
        commonStyle.put("paddingBottom", 0);
        commonStyle.put("marginTop", marginTop);
        commonStyle.put("marginLeft", marginLeft);
        commonStyle.put("marginRight", marginRight);
        commonStyle.put("marginBottom", marginBottom);
        commonStyle.put("borderWidth", 0);
        commonStyle.put("borderColor", "transparent");
        commonStyle.put("borderStyle", "solid");
        commonStyle.put("borderRadius", borderRadius);
        commonStyle.put("boxShadow", "");
        commonStyle.put("fontSize", 14);
        commonStyle.put("fontWeight", 400);
        commonStyle.put("lineHeight", 24);
        commonStyle.put("letterSpacing", 0);
        commonStyle.put("textAlign", "left");
        commonStyle.put("color", "#333");
        commonStyle.put("backgroundColor", backgroundColor);
        commonStyle.put("backgroundImage", "");
        commonStyle.put("backgroundSize", "contain");
        commonStyle.put("backgroundRepeat", "no-repeat");
        commonStyle.put("backgroundPosition", "center");
        commonStyle.put("opacity", 1);
        commonStyle.put("rotate", 0);
        commonStyle.put("zIndex", 1);
        return commonStyle;
    }
}
